`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 01/25/2017 09:53:39 AM
// Design Name: 
// Module Name: debouncer
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module debouncer(
    input clk,
    input din,
    output dout
    );
    parameter COUNTER_WIDTH=16;
    parameter COUNTER_MAXIMUM=2**16-1;
    reg [COUNTER_WIDTH-1:0] counter;
    reg data;
    reg transitioning;
    
    assign dout = data;
    always@(posedge clk)
        if (transitioning == 0) begin
            if (din != data) begin
                transitioning <= 1;
                counter <= 0;
            end
        end else if (din != data) begin
            if (counter >= COUNTER_MAXIMUM) begin 
                transitioning <= 0;
                data <= din;
            end else
                counter <= counter + 1;
        end else
            transitioning <= 0;
endmodule
